from enum import Enum
from typing import Tuple, Optional, Callable


        
def After():
    '''
    Annotation to place before a class method.
    All it does is setting an attribute to the method
    
    '''    

    
    def doAnnotate(annotatedmethod):
        setattr(annotatedmethod,'__after__', True)
        return annotatedmethod

    
    '''
    A bit complex mechanism that just sets
    attribute __after__ of the annotated class
    '''
    return doAnnotate


##### support functions.
# these are static functions because they handle class objects directly



def getAfter( ob )-> Optional[Callable]:
    '''
    @param ob: a class that may have a @Before annotated method
    @return method in clas that has @Before annotation, or None
    '''
    for fname in dir(ob):
        func = getattr(ob, fname)
        # 397 check exact value of attribute, avoiding mocks
        if hasattr(func, '__after__') and getattr(func, '__after__')==True:
            return func
    return None


