from enum import Enum
from typing import Tuple, Optional, Callable


        
def Ignore():
    '''
    Annotation to indicate a test has to be ignored/skipped
    '''    

    
    def doAnnotate(annotatedmethod):
        setattr(annotatedmethod,'__ignore__', True)
        return annotatedmethod

    
    '''
    A bit complex mechanism that just sets
    attribute __after__ of the annotated class
    '''
    return doAnnotate


##### support functions.
# these are static functions because they handle class objects directly



def getIgnored( method )-> bool:
    '''
    @param  method a method in a class
    @return true iff the method has attribute __ignore__
    '''
    return hasattr(method, '__ignore__') and getattr(method, '__ignore__')==True
    

