from __future__ import annotations
from enum import Enum
from typing import Type, Tuple, Optional, Callable
import unitpy
        
def RunWith(runner): #Type[Runner]=JUnit4ClassRunner):
    '''
    Annotation to place before a class to indicate how tests are to be run
    All it does is setting an attribute to the method
    
    '''    
    def doAnnotate(annotatedmethod):
        setattr(annotatedmethod,'__runwith__', runner)
        return annotatedmethod

    
    '''
    A bit complex mechanism that just sets
    attribute __runwith__ of the annotated class to the runner to use
    . 
    @param subclassnames a runner class.
    '''
    return doAnnotate


##### support functions.
# these are static functions because they handle class objects directly



def getRunWith( ob )-> Type: #Type[Runner]
    '''
    @param ob: a class that may have a @RunWith annotated method
    @return the runner CLASS to use. Returns default runner if class is not annotated
    '''
    if hasattr(ob, '__runwith__'):
        return getattr(ob,'__runwith__')
    return unitpy.Runner.JUnit4ClassRunner # the default


